#################################################################################
# Title            : CFSLR.R 
# Description      : Computes the photovoltaic capacity factor 
# Author(s)        : Lluís Palma (lluis.palma@bsc.es) 
# Date             : August 2020
# Dependencies     : None 
# Inputs           : [temp] - Daily temperature value (K) 
#                    [rad]  - Daily surface solar radiation downwards value
#                             (W/m2) 
# Outputs          : [PV_CF] - Photovoltaic capacity factor (%) 
#################################################################################

#=======================
# Cross rsds(rad) with tas(temp), and obtain CF.
#=======================

solar2CF <- function(temp,rad)
{
  PV_CF <- 100*0.9*(1-0.00042*(temp-25.0))*rad/1000 
  return(PV_CF)
}

