WindCapacityFactor_duplicate <- function (wind, IEC_class = c("I", "I/II", "II", "II/III", "III"), 
          dates = NULL, start = NULL, end = NULL, time_dim = "time", 
          ncores = NULL) 
{
  library(CSIndicators)
  IEC_class <- match.arg(IEC_class)
  pc_files <- c(I = "Enercon_E70_2.3MW.txt", `I/II` = "Gamesa_G80_2.0MW.txt", 
                II = "Gamesa_G87_2.0MW.txt", `II/III` = "Vestas_V100_2.0MW.txt", 
                III = "Vestas_V110_2.0MW.txt")
  pc_file <- system.file("power_curves", pc_files[IEC_class], 
                         package = "CSIndicators", mustWork = T)
  pc <- read_pc_duplicate(pc_file)
  if (!is.null(start) && !is.null(end)) {
    if (is.null(dates)) {
      warning("Parameter 'dates' is NULL and the average of the ", 
              "full data provided in 'data' is computed.")
    }
    else {
      if (!any(c(is.list(start), is.list(end)))) {
        stop("Parameter 'start' and 'end' must be lists indicating the ", 
             "day and the month of the period start and end.")
      }
      if (!is.null(dim(dates))) {
        wind <- CSIndicators::SelectPeriodOnData(data = wind, dates = dates, 
                                   start = start, end = end, time_dim = time_dim, 
                                   ncores = ncores)
      }
      else {
        warning("Parameter 'wind' must have named dimensions if 'start' and ", 
                "'end' are not NULL. All data will be used.")
      }
    }
  }
  cf <- wind2CF_duplicate(wind, pc)
  dim(cf) <- dim(wind)
  return(cf)
}
