#!/bin/bash

# Región a recortar
lon_min=-12
lon_max=30
lat_min=35
lat_max=65
# Variables a procesar
variables=("vas")

# Años válidos
start_year=1960
end_year=2021

for var in "${variables[@]}"; do
  input_dir="/esarchive/recon/ecmwf/era5/1hourly/${var}-r1440x721cds"
  output_dir="/esarchive/scratch/smoreno/recon/era5/1hourly/${var}-r1440x721cds"
  mkdir -p "$output_dir"

  for file in "$input_dir"/*.nc; do
    filename=$(basename "$file")
    year=$(echo "$filename" | grep -oE '[0-9]{4}')

    if [[ $year -ge $start_year && $year -le $end_year ]]; then
      echo "Cropping $filename..."
      cdo -s sellonlatbox,${lon_min},${lon_max},${lat_min},${lat_max} "$file" "$output_dir/$filename"
    fi
  done
done
