# source('config.R')
# model <- 'EC-Earth3-i4'
# variables <- c('uas')
# variable <- 'uas'
# members <- paste0('r',1:10,'i4p1f1')
# grid <- paste0('/esarchive/recon/ecmwf/era5/1hourly/',variable,'-r1440x721cds/',variable,'_199001.nc') #config$grid_25
# region <- 'Canary'
# crop_region <- c(config$regions[[region]]$lon_min,config$regions[[region]]$lon_max,config$regions[[region]]$lat_min,config$regions[[region]]$lat_max)
# output_dir = '/esarchive/scratch/smoreno/capacity_outputs/temporal_files'
# 
# 
# interpolate_CDO <- function(member,
#                             model,
#                             variable,
#                             grid,
#                             crop_region,
#                             output_dir_base) {
#   library(parallel)
# 
#   # Directorio de entrada según variable y modelo
#   if (variable %in% c('uas', 'vas')) {
#     if (model == 'EC-Earth3-i4'){
#       input_dir <- paste0('/esarchive/exp/CMIP6/dcppA-hindcast/EC-Earth3/DCPP/EC-Earth-Consortium/EC-Earth3/dcppA-hindcast/',
#                           member, '/6hrPlevPt/', variable, '/gr/v20210910')
#     } else if (model == 'EC-Earth3-i1'){
#       input_dir <- paste0('/esarchive/exp/CMIP6/dcppA-hindcast/EC-Earth3/DCPP/EC-Earth-Consortium/EC-Earth3/dcppA-hindcast/',
#                           member, '/6hrPlevPt/', variable, '/gr/v20190713')
#     }
#   } else if (variable %in% c('rsds', 'tas')) {
#     if (model == 'EC-Earth3-i4'){
#       input_dir <- paste0('/esarchive/exp/ecearth/a3w5/original_files/cmorfiles/DCPP/EC-Earth-Consortium/EC-Earth3/dcppA-hindcast/',
#                           member, '/day/', variable, '/gr/v20210910/')
#     } else if (model == 'EC-Earth3-i1'){
#       input_dir <- paste0('/esarchive/exp/CMIP6/dcppA-hindcast/EC-Earth3/DCPP/EC-Earth-Consortium/EC-Earth3/dcppA-hindcast/',
#                           member, '/day/', variable, '/gr/v20190713/')
#     }
#   }
# 
#   output_dir <- file.path(output_dir_base, variable, model, member)
#   if (!dir.exists(output_dir)) dir.create(output_dir, recursive = TRUE)
# 
#   files_all <- list.files(input_dir, pattern = "\\.nc$", full.names = TRUE)
#   if (length(files_all) == 0) {
#     message("No se encontraron archivos .nc en: ", input_dir)
#     return(NULL)
#   }
# 
#   # Función para extraer sdate del nombre de archivo (asumiendo formato con _sYYYY)
#   get_sdate <- function(fname) {
#     # Extrae sdate que aparece como sYYYY en el nombre, ej: s2018
#     m <- regexpr("s[0-9]{4}", fname)
#     if (m[1] != -1) {
#       substr(fname, m[1] + 1, m[1] + 4)  # extrae solo el año YYYY
#     } else {
#       NA
#     }
#   }
# 
#   # Crear data.frame con archivo y sdate
#   df_files <- data.frame(file = files_all,
#                          sdate = sapply(basename(files_all), get_sdate),
#                          stringsAsFactors = FALSE)
# 
#   # Filtrar solo primeros 4 archivos por sdate
#   df_files_filtered <- do.call(rbind, lapply(split(df_files, df_files$sdate), function(d) d[1:min(4,nrow(d)), ]))
# 
#   files <- df_files_filtered$file
# 
#   process_file <- function(input_file) {
#     fname <- basename(input_file)
#     temp_file <- file.path(output_dir, paste0("remap_", fname))
#     output_file <- file.path(output_dir, paste0("final_", region, "_", fname))
#     message("Procesando: ", fname)
#     tryCatch({
#       remap_cmd <- paste0("cdo remapbil,", grid, " ", shQuote(input_file), " ", shQuote(temp_file))
#       system(remap_cmd)
#       crop_cmd <- paste0("cdo sellonlatbox,", paste(crop_region, collapse = ","), " ", shQuote(temp_file), " ", shQuote(output_file))
#       system(crop_cmd)
#       file.remove(temp_file)
#     }, error = function(e) {
#       message("Error procesando el archivo: ", fname)
#       message("Detalle: ", e$message)
#     })
#   }
# 
#   # Procesar en paralelo con 6 núcleos
#   mclapply(files, process_file, mc.cores = 1)
#   message("Procesamiento finalizado.")
# }
# 
# 
# for (variable in variables){
#   print(variable)
#   for (member in members){
#     print(member)
#     interpolate_CDO(model = model, member = member, variable = variable, grid = grid,
#                     crop_region = crop_region, output_dir = output_dir)
#   }
# }
# 
# delete_files <- function(model, member, variable, output_dir_base) {
#   output_dir <- file.path(output_dir_base, variable, model, member)
# 
#   if (variable %in% c('uas', 'vas')) {
#     temp <- '6hrPlevPt'
#   } else if (variable %in% c('rsds', 'tas')) {
#     temp <- 'day'
#   }
#   model_pattern <- if (model %in% c('EC-Earth3-i1', 'EC-Earth3-i2', 'EC-Earth3-i4')) 'EC-Earth3' else model
#   pattern <- paste0("final_", variable, "_", temp, "_", model_pattern,
#                     "_dcppA-hindcast_s[0-9]{4}-", member, "_gr_.*\\.nc$")
# 
#   files_to_delete <- list.files(output_dir, pattern = pattern, full.names = TRUE)
#   if (length(files_to_delete) > 0) {
#     message(" Borrando archivos en ", output_dir)
#     file.remove(files_to_delete)
#   } else {
#     message("No se encontraron archivos para eliminar en ", output_dir)
#   }
# }
# 
# ####
# stop('stop')
source('config.R')

model     <- 'EC-Earth3-i4'
variables <- c('vas')  
members   <- paste0('r', 1:10, 'i4p1f1')
region    <- 'Canary'
crop_margin <- 3  

crop_region_expanded <- c(
  config$regions[[region]]$lon_min - crop_margin,
  config$regions[[region]]$lon_max + crop_margin,
  config$regions[[region]]$lat_min - crop_margin,
  config$regions[[region]]$lat_max + crop_margin
)

output_dir_base <- '/esarchive/scratch/smoreno/capacity_outputs/temporal_files'
#grid_netcdf tiene que ser creado con el código de arriba comentado para asegurarse que se pueda leer igual que los modelos normales
if (region == 'Europe'){
  grid_netcdf <- paste0('/esarchive/scratch/smoreno/capacity_outputs/temporal_files/uas/EC-Earth3-i4/r1i4p1f1/final_',region,'_uas_6hrPlevPt_EC-Earth3_dcppA-hindcast_s1960-r1i4p1f1_gr_196011010000-196110311800.nc')
} else {
  grid_netcdf <- paste0('/esarchive/scratch/smoreno/capacity_outputs/temporal_files/aux/final_Canary_uas_6hrPlevPt_EC-Earth3_dcppA-hindcast_s1960-r1i4p1f1_gr_196011010000-196110311800.nc') 
}

interpolate_CDO <- function(member, model, variable, grid_netcdf, crop_region_expanded, output_dir_base) {
  library(parallel)
  
  if (variable %in% c('uas', 'vas')) {
    if (model == 'EC-Earth3-i4') {
      input_dir <- paste0(
        '/esarchive/exp/CMIP6/dcppA-hindcast/EC-Earth3/DCPP/EC-Earth-Consortium/',
        'EC-Earth3/dcppA-hindcast/', member, '/6hrPlevPt/', variable, '/gr/v20210910'
      )
    } else if (model == 'EC-Earth3-i1') {
      input_dir <- paste0(
        '/esarchive/exp/CMIP6/dcppA-hindcast/EC-Earth3/DCPP/EC-Earth-Consortium/',
        'EC-Earth3/dcppA-hindcast/', member, '/6hrPlevPt/', variable, '/gr/v20190713'
      )
    }
  } else if (variable %in% c('rsds', 'tas')) {
    if (model == 'EC-Earth3-i4') {
      input_dir <- paste0(
        '/esarchive/exp/ecearth/a3w5/original_files/cmorfiles/DCPP/EC-Earth-Consortium/',
        'EC-Earth3/dcppA-hindcast/', member, '/day/', variable, '/gr/v20210910/'
      )
    } else if (model == 'EC-Earth3-i1') {
      input_dir <- paste0(
        '/esarchive/exp/CMIP6/dcppA-hindcast/EC-Earth3/DCPP/EC-Earth-Consortium/',
        'EC-Earth3/dcppA-hindcast/', member, '/day/', variable, '/gr/v20190713/'
      )
    }
  }
  
  output_dir <- file.path(output_dir_base, variable, model, member)
  if (!dir.exists(output_dir)) dir.create(output_dir, recursive = TRUE)
  
  files_all <- list.files(input_dir, pattern = "\\.nc$", full.names = TRUE)
  if (length(files_all) == 0) {
    message("No se encontraron archivos .nc en: ", input_dir)
    return(NULL)
  }
  
  get_sdate <- function(fname) {
    m <- regexpr("s[0-9]{4}", fname)
    if (m[1] != -1) {
      substr(fname, m[1] + 1, m[1] + 4)
    } else {
      NA
    }
  }
  
  df_files <- data.frame(
    file  = files_all,
    sdate = sapply(basename(files_all), get_sdate),
    stringsAsFactors = FALSE
  )
  df_files_filtered <- do.call(rbind, lapply(split(df_files, df_files$sdate), function(d) {
    d[1:min(4, nrow(d)), ]
  }))
  files <- df_files_filtered$file
  
  process_file <- function(input_file) {
    fname       <- basename(input_file)
    crop_temp   <- file.path(output_dir, paste0("crop_", fname))
    output_file <- file.path(output_dir, paste0("final_", region, "_", fname))
    message("Procesando: ", fname)
    
    tryCatch({
      # 1) Cropear ampliado (Europa + margen)
      crop_cmd <- paste0(
        "cdo sellonlatbox,",
        paste(crop_region_expanded, collapse = ","), " ",
        shQuote(input_file), " ",
        shQuote(crop_temp)
      )
      system(crop_cmd)
      remap_cmd <- paste0(
        "cdo remapbil,", shQuote(grid_netcdf), " ",
        shQuote(crop_temp), " ",
        shQuote(output_file)
      )
      system(remap_cmd)
      
      # Eliminar archivo temporal de cropped
      file.remove(crop_temp)
    }, error = function(e) {
      message("Error procesando el archivo: ", fname)
      message("Detalle: ", e$message)
    })
  }
  
  mclapply(files, process_file, mc.cores = 5)
  message("Procesamiento finalizado para member ", member)
}

for (variable in variables) {
  print(paste0("Variable: ", variable))
  for (member in members) {
    print(paste0("  Miembro: ", member))
    interpolate_CDO(
      member               = member,
      model                = model,
      variable             = variable,
      grid_netcdf          = grid_netcdf,
      crop_region_expanded = crop_region_expanded,
      output_dir_base      = output_dir_base
    )
  }
}
