
path <- '/gpfs/scratch/bsc32/MN4/bsc32/bsc32693/data_amd/scratch/gitlab/capacity_factors'

header <- "#!/bin/bash
#!/bin/bash
#SBATCH -t 24:00:00
#SBATCH --account=bsc32
#SBATCH --qos=gp_bsces
#SBATCH -c 30
#SBATCH -J sun

#SBATCH -o /gpfs/scratch/bsc32/MN4/bsc32/bsc32693/data_amd/scratch/mn5_logs/slurm-1focus-%j.out
#SBATCH -e /gpfs/scratch/bsc32/MN4/bsc32/bsc32693/data_amd/scratch/mn5_logs/slurm-1focus-%j.err

source /gpfs/projects/bsc32/software/suselinux/11/software/Miniconda3/4.7.10/etc/profile.d/conda.sh
conda activate /gpfs/projects/bsc32/repository/apps/conda_envs/SUNSET-env_2.0.0/

"

models <- c('EC-Earth3-i1')
for (model in models){
  launcher <- paste0(path,'launcher_',model,'.sh')
  
  ## Creating the launcher
  sink(file = launcher, type = 'output')
  cat(paste0(header, 'Rscript seasons_solar.R ',model))
  sink()
  
  ## Submitting the job
  system(command = paste0('sbatch ',launcher))
  
  ## Removing the launcher
  system(command = paste0('rm ',launcher))
}
