setwd('/esarchive/scratch/smoreno/gitlab/capacity_factors/')
source('config.R')
source('means_test.R')
region <- 'Gal'
retrieve <- FALSE
config$years <- 1990:1992

    time_starting_exec <- proc.time()

    sys_info <- Sys.info()['nodename']
    machine_index <- substr(sys_info, 1, 2)
    path <- '/esarchive/recon/ecmwf/era5/monthly_mean/$var$_f1h-r1440x721cds/$var$_$year$$month$.nc'  

      data <- startR::Start(dat = path, var = 'tas',
                           lon = values(list(config$regions[[region]]$lon_min,config$regions[[region]]$lon_max)),
                           lat = values(list(config$regions[[region]]$lat_min,config$regions[[region]]$lat_max)),
                           year = paste0(config$years), month = 'all', time = 'all',
                           synonims = list(lat = c('lat','latitude'), lon = c('lon','longitude')),
                           return_vars = list(lat = NULL, lon = NULL), lon_var = 'lon', lat_var = 'lat',
                           lat_reorder = Sort(decreasing = FALSE), lon_reorder = CircularSort(-180,180),
                           num_procs = 1, retrieve = retrieve)

      dates_obs <- attr(data,"Variables")$common$time
      lon <- attr(data,'Variables')$common[['lon']]
      lat <- attr(data,'Variables')$common[['lat']]

      ## Changing paths for AMD or MN5
      # test <- apply(attr(data,"ExpectedFiles"), c(1,2,3,4), FUN = function(x) {
      #   paste0("/gpfs/scratch/bsc32/bsc32693/scratch/recon", substr(x, 23, nchar(x)))})
      # attr(data,"ExpectedFiles") <- test
      # data[2] <- paste0("/gpfs/scratch/bsc32/bsc32693/scratch/recon", substr(data[2], 23, nchar(data[2])))

          target_dims <- c('var','year','month')
          output_dims <- list(data = 'year')
          
          if (isTRUE(retrieve)) {


          } else if (isFALSE(retrieve)) {
            
            step <- startR::Step(fun = means_test,
                                 target_dims = target_dims, 
                                 output_dims = output_dims)

            wf <- startR::AddStep(inputs = list(data = data),
                                  config = config,
                                  ncores = config$ncores,
                                  step_fun = step)
            
            chunks <- list(lat = 1, lon = 1) 
              job_wallclock <- '01:00:00'
              config$ncores <- 1
        
            # output <- Compute(workflow = wf,
            #                   chunks = chunks,
            #                   threads_load = 1,
            #                   threads_compute = config$ncores,
            #                   cluster = list(queue_host = 'amd',
            #                                   r_module = "R/4.1.2-foss-2019b",
            #                                   temp_dir = '/gpfs/scratch/bsc32/bsc032693/startR_hpc/',
            #                                   CDO_module = "CDO/1.9.8-foss-2019b",
            #                                   ecflow_module = 'ecFlow',
            #                                   cores_per_job = 7,
            #                                   job_wallclock = job_wallclock,
            #                                   max_jobs = 10,
            #                                   extra_queue_params = list('#SBATCH -A bsc32', '#SBATCH -q bsc_es'),
            #                                   bidirectional = FALSE,
            #                                   polling_period = 10),
            #                   ecflow_suite_dir = '/home/Earth/smoreno/Desktop/startR_local/',
            #                   wait = TRUE)
              trretre
              output <- Compute(workflow = wf,
                                chunks = chunks,
                                threads_load = 1,
                                threads_compute = config$ncores,
                                cluster = list(queue_host = 'mn5',
                                               r_module = 'R/4.1.2-foss-2019b',
                                               temp_dir = '/gpfs/scratch/bsc32/bsc032693/startR_hpc/',
                                               CDO_module = NULL, #"CDO/1.9.8-foss-2019b",
                                               conda_env = "/gpfs/projects/bsc32/repository/apps/conda_envs/SUNSET-env_2.0.0",
                                               ecflow_module = 'ecFlow',
                                               cores_per_job = 7,
                                               job_wallclock = job_wallclock,
                                               max_jobs = 10,
                                               extra_queue_params = list('#SBATCH -A bsc32', '#SBATCH -q bsc_es'),
                                               bidirectional = FALSE,
                                               polling_period = 10),
                                ecflow_suite_dir = '/home/Earth/smoreno/Desktop/startR_local/',
                                wait = TRUE)
              
              
              res <- Compute(workflow = wf,
                             chunks = chunks,
                             threads_load = 1,
                             threads_compute = config$ncores,
                             cluster = list(
                               queue_host = 'nord4',
                               expid = "a9gq",
                               hpc_user = "bsc032693",
                               conda_env = "/gpfs/projects/bsc32/repository/apps/conda_envs/SUNSET-env_2.0.0",
                               autosubmit_module = 'autosubmit/4.0.98-foss-2015a-Python-3.7.3',
                               # autosubmit_module = 'autosubmit/4.0.98-foss-2021b-Python-3.9.6',
                               cores_per_job = 1,
                               job_wallclock = '00:30:00',
                               max_jobs = 4,
                               special_setup = 'nord4'
                             ),
                             workflow_manager = 'autosubmit',
                             autosubmit_suite_dir = "/home/Earth/smoreno/startR_local_autosubmit/",
                             autosubmit_server = 'bscesautosubmit01',
                             wait = TRUE
              )
              
          } else {stop('retrieve must be TRUE or FALSE')}
          
          
          saveRDS(object = list(obs = output$obs,
                                lon = lon,
                                lat = lat,
                                config = config),
          file = paste0(config$objetos_aux,'test_amd.rds'))

    print(paste0('Finished in ',round(x = (proc.time() - time_starting_exec)[3]/60, digits = 0),' min.'))
  
